#ifndef CORE_FILE_READER_HPP
#define CORE_FILE_READER_HPP

#include <stdio.h>

#include "core/io/File.hpp"

namespace Core {
    class FileReader final {
        FILE* file;
        Path path;

    public:
        FileReader();
        FileReader(const FileReader& other) = delete;
        FileReader(FileReader&& other);
        ~FileReader();
        FileReader& operator=(const FileReader& other) = delete;
        FileReader& operator=(FileReader&& other);
        const Path& getPath() const;
        Error open(const Path& path);
        Error open(const char* path);
        Error readChar(int& c);
        Error readChars(char* buffer, size_t bufferSize);
        void swap(FileReader& other);
    };
}

#endif
