#include "core/Thread.h"

#include <string.h>

#include "ErrorSimulator.h"
#include "core/Logger.h"

bool joinThreadSafe(thrd_t* t) {
    static thrd_t nullThread = {0};
    if(memcmp(t, &nullThread, sizeof(thrd_t)) != 0) {
        if(THREAD_JOIN_FAIL || thrd_join(*t, nullptr) != thrd_success) {
            REPORT(LOG_ERROR, "cannot join thread");
            return true;
        }
        *t = (thrd_t){0};
    }
    return false;
}
